# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs}}
%{!?aprconf: %{expand: %%define aprconf %{_bindir}/apr-config}}
%{!?libtool: %{expand: %%define libtool %{_sysconfdir}/httpd/build/libtool}}
%define aplibdir %(%{apxs} -q LIBEXECDIR 2>/dev/null)
%define apconfdir %(%{apxs} -q SYSCONFDIR 2>/dev/null)
%define aplogdir logs
%define aprincludes %(%{aprconf} --includes 2>/dev/null)
%define tc5dir %{_datadir}/tomcat5

Name:      mod_jk
Epoch:     0
Version:   1.2.23
Release:   3%{?dist}
Summary:   Tomcat mod_jk connector for Apache

Group:     Internet/WWW/Servers
License:   Apache Software License
URL:       http://tomcat.apache.org
Source0:   http://www.apache.org/dist/tomcat/tomcat-connectors/jk/source/tomcat-connectors-%{version}-src.tar.gz
Source1:   %{name}.conf.sample
Source3:   mod_jk.conf.jboss.sample
Source4:   workers.properties.jboss.sample
Patch0:    tomcat-connectors-jk-%{version}-libtool-tag.patch
Patch1: %{name}-workers.properties.patch
Patch2:    jakarta-tomcat-connectors-jk-%{version}-pointer-cast.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: %{apxs}
BuildRequires: %{_bindir}/perl
BuildRequires: ant-trax
BuildRequires: java-1.5.0-bea-devel
BuildRequires: jpackage-utils >= 0:1.5.38
BuildRequires: libtool
BuildRequires: xalan-j2 >= 2.7.0

%description
Tomcat %{name} connector for Apache.

By default, this package builds %{name} for Apache 2.0.x. To build for
Apache 1.3.x, use the "--with apache1" option for the rpm build
command. To use a custom apxs, use "--define 'apxs /path/to/your/apxs'".
Additionally, for Apache 2.0.x, if your "apxs -q LIBTOOL" doesn't return
anything and the libtool that comes with Apache isn't located in
%{libtool}, use "--define 'libtool /path/to/your/libtool'".
To customize the apr-config executable used (not always needed), use
"--define 'aprconf /path/to/your/apr-config'".

%package ap13
Summary: Tomcat %{name} connector for Apache 1.3.x
Group: Internet/WWW/Servers
Provides: %{name} = %{epoch}:%{version}-%{release}
Obsoletes: tomcat-mod

%description ap13
Tomcat %{name} connector for Apache 1.3.x.

%package ap20
Summary: Tomcat %{name} connector for Apache 2.0.x
Group: Internet/WWW/Servers
Provides: %{name} = %{epoch}:%{version}-%{release}
Obsoletes: tomcat-mod

%description ap20
Tomcat %{name} connector for Apache 2.0.x.

%package manual
Summary: Tomcat %{name} connector manual
Group: Internet/WWW/Servers

%description manual
Tomcat %{name} connector manual.

%package tools
Group: Internet/Log Analysis
Summary: Analysis and report tools for %{name}

%description tools
Miscellaneous %{name} analysis and report tools.

%prep
%setup -q -n tomcat-connectors-%{version}-src
%if 0%{?_with_apache1:1}
%patch0 -p1 -b .libtool
%endif
%patch1 -p0
%patch2 -p1 -b .pointer-cast
%{__sed} -i -e 's|^(APXSCPPFLAGS=.*)$|$1 %{aprincludes}|' \
    native/common/Makefile.in

%build
pushd native
    [ -x ./configure ] || sh ./buildconf.sh
    %configure \
        --with-apxs="%{apxs}" \
        %{?_with_apache1: --enable-EAPI}
    # See <http://marc.theaimsgroup.com/?l=tomcat-dev&m=105600821630990>
    %if 0%{!?_with_apache1:1}
        export LIBTOOL="`%{apxs} -q LIBTOOL 2>/dev/null`"
        # Handle old apxs (without -q LIBTOOL), eg Red Hat 8.0 and 9.
        if test -z "$LIBTOOL"; then
            LIBTOOL="%{libtool}"
        fi
        make %{?_smp_mflags} \
        LIBTOOL="$LIBTOOL" \
        EXTRA_CFLAGS="$RPM_OPT_FLAGS" \
        EXTRA_CPPFLAGS="%{aprincludes}"
    %endif
    %if 0%{?_with_apache1:1}
        make %{?_smp_mflags} EXTRA_CFLAGS="$RPM_OPT_FLAGS"
    %endif
popd
pushd xdocs
    CLASSPATH="$(build-classpath xalan-j2-serializer)" %ant
popd

%install
%{__rm} -rf $RPM_BUILD_ROOT
install -p -m 0644 %{SOURCE1} %{SOURCE3} %{SOURCE4} .
%{__mkdir} -p _ap20
%{__sed} -i -e 's|/usr/local/bin\b|%{_bindir}|' tools/reports/*.pl
%{__sed} -i -e 's|\@confdir\@|%{apconfdir}|' \
    -e 's|\@logdir\@|%{aplogdir}|' \
    -e 's|\@tomcatdir\@|%{tc5dir}|' \
    -e 's|\@java_home\@|%{java_home}|' \
    %{name}.conf.sample conf/workers.properties
%{__cp} conf/workers.properties ./workers.properties.sample
%{__grep} -v ^AddModule %{name}.conf.sample > _ap20/%{name}.conf.sample
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}/%{aplibdir}
%if 0%{!?_with_apache1:1}
    %{__install} -p -m 0755 native/apache-2.0/%{name}.so \
        ${RPM_BUILD_ROOT}/%{aplibdir}/%{name}.so
%endif
%if 0%{?_with_apache1:1}
    %{__install} -p -m 0755 native/apache-1.3/%{name}.so.0.0.0 \
        ${RPM_BUILD_ROOT}/%{aplibdir}/%{name}.so
%endif
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}/%{_bindir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}/%{_var}/run/%{name}
%{__install} -p -m 0755 tools/reports/*.pl ${RPM_BUILD_ROOT}/%{_bindir}

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%if 0%{?_with_apache1:1}
%files ap13
%defattr(-,root,root,-)
%doc KEYS LICENSE NOTICE %{name}.conf.sample workers.properties.sample
%doc mod_jk.conf.jboss.sample workers.properties.jboss.sample
%doc native/README native/CHANGES native/NEWS native/TODO
%{aplibdir}/*
%dir %{_var}/run/%{name}
%endif

%if 0%{!?_with_apache1:1}
%files ap20
%defattr(-,root,root,-)
%doc KEYS LICENSE NOTICE _ap20/%{name}.conf.sample workers.properties.sample
%doc mod_jk.conf.jboss.sample workers.properties.jboss.sample
%doc native/README native/CHANGES native/NEWS native/TODO
%{aplibdir}/*
%dir %{_var}/run/%{name}
%endif

%files manual
%defattr(0644,root,root,0755)
%doc build/docs/*

%files tools
%defattr(-,root,root,-)
%doc tools/reports/README.txt
%{_bindir}/*

%changelog
* Thu Jun 07 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.2.23-3
- Own /var/run/mod_jk for shared memory segments etc. to be placed and
  avoid SELinux pains
- Resolves: bug 225452

* Mon Jun 04 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.2.23-2.el5s2
- Fix mod_jk.conf
- Resolves: bug 229164

* Tue May 29 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.2.23-1.el5s2
- Update to 1.2.23-1jpp
- Re-add some patches (pointer cast)
- Rename/merge -libtool-tag.patch
- Re-add jboss specific samples

* Thu May 03 2007 Deepak Bhole <dbhole@redhat.com> - 0:1.2.22-1.el5s2
- Update to 1.2.22
- Update patch names, and make the patch names use %%version in spec file
- Avoid use of ForwardURICompat in mod_jk.conf jboss sample, replaced with
  ForwardURICompatUnparsed. See bug 237656
- Use java-1.5.0-bea-devel to build

* Fri Apr 20 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.2.21-1.el5s2
- Use new naming convention
- First rebuild for Stacks V2
- Add additional mod_jk.conf.jboss.sample and workers.properties.jboss.sample
  as references for users to use mod_jk with JBoss, detailed instructions can
  be found at: http://www.jboss.org/wiki/Wiki.jsp?page=UsingMod_jk1.2WithJBoss 
- Regenerate jni patch since the previous one no longer applied
  (note: we still dont build the JNI connectors)
- Rename the patches to signify switch to 1.2.21

* Mon Mar 05 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.2.21-1.el4s1.1
- Upgrade

* Mon Mar 05 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.2.21-1jpp
- Upgrade to 1.2.21
WARNING: Critical vulnerabilities in previous versions

* Mon Feb 26 2007 Vivek Lakshmanan <vivekl@redhat.com> 1.2.20-1.el4s1.2
- Add patch for jk_uri_worker_map from jclere
- Resolves: #230045

* Fri Jan 05 2007 Deepak Bhole <dbhole@redhat.com> 1.2.20-1.el4s1.1
- Upgrade to 1.2.20

* Fri Jan  5 2007 Ville Skyttä <scop at jpackage.org> - 0:1.2.20-1jpp
- 1.2.20.

* Wed Nov 29 2006 Deepak Bhole <dbhole@redhat.com> 1.2.19-1.el4s1.1
- Build into Stacks V1.1
- Disable JNI

* Tue Sep 19 2006 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.2.19-2jpp
- Remove unsupported JNI workers.

* Mon Sep 18 2006 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.2.19-1jpp
- Upgrade to version 1.2.19.
- Add versioned requirement on xalan-j2 (for xalan-j2-serializer).

* Fri Sep 15 2006 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.2.18-2jpp_7rh
- Rebuild.

* Mon Sep 11 2006 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.2.18-2jpp_6rh
- Rebuild.

* Mon Sep 11 2006 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.2.18-2jpp_5rh
- Re-enable all patches for x86-64.

* Fri Aug 25 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.2.18-2jpp_4rh
- Re-add x86_64

* Fri Aug 25 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.2.18-2jpp_3rh
- Re-add other arches but for x86_64

* Fri Aug 25 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.2.18-2jpp_2rh
- Rebuild excluding ppc ia64 x86_64

* Thu Aug 24 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.2.18-2jpp_1rh
- Merge with upstream for upgrade

* Thu Aug 24 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.2.18-2jpp
- Add header

* Tue Aug 22 2006 Ville Skyttä <scop at jpackage.org> - 0:1.2.18-1jpp
- 1.2.18.

* Thu Dec 22 2005 Ville Skyttä <scop at jpackage.org> - 0:1.2.15-1jpp
- 1.2.15.

* Mon Oct 24 2005 Jason Corley <jason.corley@gmail.com> - 0:1.2.14.1-2jpp
- Add xalan-j2 BuildRequires

* Thu Oct 13 2005 Ville Skyttä <scop at jpackage.org> - 0:1.2.14.1-1jpp
- 1.2.14.1.

* Mon Jun 27 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.2.6-3jpp_7rh
- Add fix for pointer cast warnings.

* Mon Jun 27 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.2.6-3jpp_6rh
- Remove jni_md.h check from configure.

* Wed Jun 22 2005 Fernando nasser <fnasser@redhat.com> - 0:1.2.6-3jpp_5rh
- Rebuild

* Mon Apr 18 2005 Jason Corley <jason.corley@gmail.com> - 0:1.2.10-1jpp
- 1.2.10

* Tue Feb 22 2005 Ville Skyttä <scop at jpackage.org> - 0:1.2.8-2jpp
- Revert *.pl interpreters to %%{__perl}.

* Fri Feb 18 2005 Ville Skyttä <scop at jpackage.org> - 0:1.2.8-1jpp
- 1.2.8.
- Build for Apache 2.x by default, "--with apache1" for Apache 1.3.x.

* Wed Feb 16 2005 Fernando nasser <fnasser@redhat.com> - 0:1.2.6-3jpp_3rh
- Add ppc64 and x86_64
- Rebuild

* Wed Feb 16 2005 Fernando nasser <fnasser@redhat.com> - 0:1.2.6-3jpp_2rh
- Rebuild

* Wed Dec 08 2004 Fernando nasser <fnasser@redhat.com> - 0:1.2.6-3jpp_1rh
- First Red Hat release
- Build by default for Apache 2.0.x
- Add --tag to remaining LIBTOOL invocations

* Mon Oct 4 2004 Nicolas Mailhot <nim@jpackage.org> - 0:1.2.6-3jpp
- do not apply RHES 2.1 libtool workaround to apache2 builds

* Mon Oct 4 2004 Nicolas Mailhot <nim@jpackage.org> - 0:1.2.6-2jpp
- Add RHES 2.1 libtool workaround

* Wed Sep 29 2004 Nicolas Mailhot <nim@jpackage.org> - 0:1.2.6-1jpp
- Update to 1.2.6 as per Henri's suggestion:
  "JK2 is not production ready"
- Change default target from Tomcat 4 to Tomcat 5. Tomcat 5.5 is out and 
  Tomcat 5 is now the official stable version
- initial built on RHES 3, RHES 2.1 and RH 7.3

* Sat Nov 15 2003 Ville Skyttä <scop at jpackage.org> - 0:1.2.5-2jpp
- Use apr-config if available for apache2 to allow building on FC1.
- Include README and CHANGES.txt in docs.

* Mon Oct 13 2003 Ville Skyttä <scop at jpackage.org> - 0:1.2.5-1jpp
- Update to 1.2.5 final.

* Thu Jul 24 2003 Ville Skyttä <scop at jpackage.org> - 0:1.2.5-0.1jpp
- Update to unofficial 1.2.5.

* Fri Jun 27 2003 Ville Skyttä <scop at jpackage.org> - 0:1.2.4-1jpp
- Use the libtool that comes with Apache 2 for building with it.
- Provide a fallback "--define 'libtool /path/to/your/libtool'".
- Thanks to Henri Gomez for the above fixes.

* Thu Jun 26 2003 Ville Skyttä <scop at jpackage.org> - 0:1.2.4-0.2jpp
- Add --with apache2 rpmbuild option.
- Add manual subpackage.

* Wed Jun 25 2003 Ville Skyttä <scop at jpackage.org> - 0:1.2.4-0.1jpp
- Made apxs customizable with
  "rpmbuild --rebuild --define 'apxs /path/to/your/apxs'".

* Wed Jun 25 2003 Ville Skyttä <scop at jpackage.org> - 0:1.2.4-0jpp
- Update to 1.2.4, massive spec cleanup (only mod_jk for Apache 1.3 now).

* Tue Dec 17 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.2.2-1jpp
- jtc 1.2.2
- add Obsoletes tomcat-mod

* Tue Nov 26 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.2.1-1jpp
- jtc 1.2.1
- add package mod_jk-tools (require gd 1.8.x and perl modules GD 1.4.1, 
  GD Graph, GD TextUtil  and StatisticsDescriptive)

* Tue Oct 08 2002 Henri Gomez <hgomez@users.sourceforge.net> 2.0.1-1jpp
- jtc snapshot from JK 2.0.1 beta release
- apr / apr-util / apr-devel packages required for JK2 build and Apache 1.3,
  you could find them at : http://ftp.falsehope.com/home/gomez/apr/
- apache2 / apache2-devel packages required Apache 2 build,
  you could find them at : http://ftp.falsehope.com/home/gomez/apache2/

* Fri Oct 04 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.2.0-2jpp
- jtc 1.2.0 built against Apache 2.0.43

* Wed Oct 02 2002 Henri Gomez <hgomez@users.sourceforge.net> 2.0.0-1jpp
- jtc snapshot from JK 2.0.0 beta release
- apr / apr-util / apr-devel packages required for JK2 build and Apache 1.3,
  you could find them at : http://ftp.falsehope.com/home/gomez/apr/
- apache2 / apache2-devel packages required Apache 2 build,
  you could find them at : http://ftp.falsehope.com/home/gomez/apache2/

* Wed Sep 25 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0.jk1.2.0-1jpp
- jtc snapshot from JK 1.2.0 release

* Fri Aug 22 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0.4.1.9-1jpp
- jtc snapshot from tomcat 4.1.9 beta
- webapp not build since it requires autoconf > 2.5 not available in rpm distribs 

* Thu Feb 14 2002 Henri Gomez <hgomez@users.sourceforge.net>
- Initial tomcat-connectors release
- use the jakarta-tomcat-connectors-4.0.2-01-src 
  (which correct some auth problems with ajp13)

